export make_row, make_grid, setindex_

function make_row(columns::Integer)
    #Returns tuple, needs to be Node(:div, tuple..) before use
    style = Dict(:display => "inline-table",
                 :verticalAlign => "top",
                 :width => "$(100/columns)%")
    #:transform => "scale($(1/columns))")
    (Node(:div, style=style, "Lorem Ipsum") for i in 1:columns)
end

"""
Constructs a Node containing empty nodes in a row by column grid. A member can then be accessed using [n,m] syntax, but [n][m] accesses the element container; [n][m][1] is equivalent to [n,m]. This is done to maintain the style (width etc) of the subelements.

"""

function make_grid(rows::Integer, columns::Integer, width = 800, height = 1000)
    style_row  = Dict(:height => "$(100/rows)%", :overflow => "auto")
    style_grid = Dict(:width  => width, :height => height)
    Node(:div, style=style_grid, (Node(:div, style=style_row, make_row(columns)...)
                                 for i in 1:rows)...)
end


function Base.getindex(grid::WebIO.Node{WebIO.DOM}, ind::Integer)
    grid.children[ind]
end

function Base.getindex(grid::WebIO.Node{WebIO.DOM}, row::Integer, column::Integer)
    grid[row][column][1]
end

"""
WebIO.Node objects are immutable, so setindex_ simply returns a modified version of the original
"""
function setindex_(grid::WebIO.Node{WebIO.DOM},
                   new_value,
                  ind::Integer)
    #Make this look nicer
    setchild(grid, ind, setchild(grid[ind], 1, Node(:div, new_value)))
end

function setindex_(grid::WebIO.Node{WebIO.DOM},
                   new_value,
                   row::Integer,
                   column::Integer)
    #Make this look nicer
    setchild(grid, row, setindex_(grid[row], new_value, column))
end		
